export declare type Syntax = "r" | "c" | "c++" | "clang" | "latex" | "go" | "rust" | "CSS" | "html" | "xml" | "bibtex" | "markdown" | "Markdown" | "knitr" | "json" | "JSON" | "latex" | "yaml" | "python" | "python3" | "py" | "R" | "RMarkdown" | "TypeScript" | "JavaScript" | "prettier" | "typescript" | "css" | "babel" | "gofmt" | "clang-format" | "rustfmt" | "tsx" | "jsx" | "yapf" | "yapf3" | "formatR" | "latexindent" | "bib-biber" | "xml-tidy" | "html-tidy" | "DOES_NOT_EXIST";
export declare type Parser = Syntax;
export declare type Tool = "r" | "yapf" | "yapf3" | "python" | "knitr" | "formatR" | "clang-format" | "latex" | "latexindent" | "gofmt" | "xml-tidy" | "html-tidy" | "rustfmt" | "bib-biber" | "prettier" | "css" | "babel" | "typescript" | "json" | "yaml" | "markdown" | "DOES_NOT_EXIST";
export declare const file_extensions: string[];
export declare type Exts = typeof file_extensions[number];
declare type Ext2Syntax = {
    [s in Exts]: Parser;
};
export declare const ext2syntax: Readonly<Ext2Syntax>;
export declare const ext2parser: Readonly<Ext2Syntax>;
declare type Config = {
    [s in Parser]: Tool;
};
export declare const syntax2tool: Readonly<Config>;
export declare const parser2tool: Readonly<Config>;
declare type Langs = {
    [s in Parser]?: string;
};
export declare const syntax2display: Readonly<Langs>;
export declare const parser2display: Readonly<Langs>;
declare type Tool2Display = {
    [s in Tool]?: string[];
};
export declare const tool2display: Readonly<Tool2Display>;
export {};
