export declare type ConfigValid = Readonly<string[]> | ((val: string) => boolean);
export declare type RowType = "header" | "setting";
export declare type SiteSettingsKeys = "theming" | "site_name" | "site_description" | "account_creation_email_instructions" | "help_email" | "logo_square" | "logo_rectangular" | "splash_image" | "index_info_html" | "organization_name" | "organization_email" | "organization_url" | "terms_of_service" | "terms_of_service_url" | "commercial" | "max_trial_projects" | "nonfree_countries" | "google_analytics" | "kucalc" | "dns" | "ssh_gateway" | "versions" | "version_min_project" | "version_min_browser" | "version_recommended_browser" | "iframe_comm_hosts" | "onprem_quota_heading" | "default_quotas" | "max_upgrades" | "email_enabled" | "verify_emails" | "email_signup";
export interface Config {
    readonly name: string;
    readonly desc: string;
    readonly default: string;
    readonly valid?: ConfigValid;
    readonly password?: boolean;
    readonly show?: (conf: any) => boolean;
    readonly to_val?: (val: string) => boolean | string | number;
    readonly to_display?: (val: string) => string;
    readonly hint?: (val: string) => string;
    readonly type?: RowType;
    readonly clearable?: boolean;
    readonly multiline?: number;
}
export declare type SiteSettings = Record<SiteSettingsKeys, Config>;
export declare const is_email_enabled: (conf: any) => boolean;
export declare const only_for_smtp: (conf: any) => boolean;
export declare const only_for_sendgrid: (conf: any) => boolean;
export declare const only_for_password_reset_smtp: (conf: any) => boolean;
export declare const only_onprem: (conf: any) => boolean;
export declare const only_cocalc_com: (conf: any) => boolean;
export declare const not_cocalc_com: (conf: any) => boolean;
export declare const show_theming_vars: (conf: any) => boolean;
export declare const only_commercial: (conf: any) => boolean;
export declare const to_bool: (val: any) => boolean;
export declare const only_booleans: string[];
export declare const to_int: (val: any) => number;
export declare const only_ints: (val: any) => boolean;
export declare const only_nonneg_int: (val: any) => boolean;
export declare const split_iframe_comm_hosts: (hosts: any) => any;
export declare const KUCALC_DISABLED = "no";
export declare const KUCALC_COCALC_COM = "yes";
export declare const KUCALC_ON_PREMISES = "onprem";
export declare const site_settings_conf: SiteSettings;
