export { get_start_time_ts, get_uptime, log, wrap_log } from "./log";
import { is_array, is_integer, is_object, is_string, is_date, is_set } from "./type-checking";
export { is_array, is_integer, is_object, is_string, is_date, is_set };
export { map_limit, map_max, map_min, sum, is_zero_map, map_without_undefined, map_mutate_out_undefined, } from "./maps";
export { done, done1, done2 } from "./done";
export { cmp, cmp_Date, cmp_moment, cmp_array, timestamp_cmp, field_cmp, is_different, is_different_array, shallowCompare, all_fields_equal, } from "./cmp";
export { server_time, server_milliseconds_ago, server_seconds_ago, server_minutes_ago, server_hours_ago, server_days_ago, server_weeks_ago, server_months_ago, milliseconds_before, seconds_before, minutes_before, hours_before, days_before, weeks_before, months_before, expire_time, YEAR, } from "./relative-time";
export { set_local_storage, get_local_storage, has_local_storage, delete_local_storage, local_storage_length, } from "./local-storage";
import sha1 from "sha1";
export { sha1 };
import * as lodash from "lodash";
import * as immutable from "immutable";
export declare const keys: (any: any) => string[];
import { required, defaults, types } from "./opts";
export { required, defaults, types };
interface SplittedPath {
    head: string;
    tail: string;
}
export declare function path_split(path: string): SplittedPath;
export declare function capitalize(s: string): string;
export declare function make_valid_name(s: string): string;
export declare function filename_extension(filename: string): string;
export declare function filename_extension_notilde(filename: string): string;
export declare function separate_file_extension(name: string): {
    name: string;
    ext: string;
};
export declare function change_filename_extension(path: string, new_ext: string): string;
export declare function normalized_path_join(...parts: any[]): string;
export declare function splitlines(s: string): string[];
export declare function split(s: string): string[];
export declare function merge(dest: any, ...objs: any[]): any;
export declare function merge_copy(...objs: any[]): object;
export declare function copy_with<T>(obj: T, w: string | string[]): Partial<T>;
export declare function copy_without(obj: object, w: string | string[]): object;
export declare const deep_copy: <T>(value: T) => T;
export declare function set(v: string[]): {
    [key: string]: true;
};
export declare function copy<T>(obj: T): T;
export declare function startswith(s: any, x: string | string[]): boolean;
export declare function endswith(s: any, t: any): boolean;
export declare function uuid(): string;
export declare function is_valid_uuid_string(uuid: string): boolean;
export declare function assert_uuid(uuid: string): void;
export declare function uuidsha1(data: string): string;
export declare function len(obj: object | undefined | null): number;
export declare function milliseconds_ago(ms: number): Date;
export declare function seconds_ago(s: number): Date;
export declare function minutes_ago(m: number): Date;
export declare function hours_ago(h: number): Date;
export declare function days_ago(d: number): Date;
export declare function weeks_ago(w: number): Date;
export declare function months_ago(m: number): Date;
export declare function how_long_ago_ms(ts: Date | number): number;
export declare function how_long_ago_s(ts: Date | number): number;
export declare function how_long_ago_m(ts: Date | number): number;
export declare function mswalltime(t?: number): number;
export declare function walltime(t?: number): number;
export declare function encode_path(path: any): any;
export declare function is_valid_email_address(email: string): boolean;
export declare const to_json: {
    (value: any, replacer?: ((this: any, key: string, value: any) => any) | undefined, space?: string | number | undefined): string;
    (value: any, replacer?: (string | number)[] | null | undefined, space?: string | number | undefined): string;
};
export declare function plural(number: any, singular: any, plural?: string): any;
export declare function trunc(s: any, max_length?: number): any;
export declare function trunc_middle(s: any, max_length?: number): any;
export declare function trunc_left(s: any, max_length?: number): string | undefined;
export declare function getIn(x: any, path: string[], default_value?: any): any;
export declare function replace_all(s: string, search: string, replace: string): string;
export declare function replace_all_function(s: string, search: string, replace_f: (i: number) => string): string;
export declare function path_to_title(path: string): string;
export declare function list_alternatives(names: any): string;
export declare function to_user_string(x: any): string;
export declare function delete_null_fields(obj: object): void;
export declare function unreachable(x: never): void;
export declare function bind_methods<T extends object>(obj: T, method_names?: undefined | string[]): T;
export declare function human_readable_size(bytes: number | null | undefined): string;
export declare const re_url: RegExp;
export declare function contains_url(str: string): boolean;
export declare function hidden_meta_file(path: string, ext: string): string;
export declare function history_path(path: string): string;
export declare function meta_file(path: string, ext: string): string;
export declare function tuple<T extends string[]>(o: T): T;
export declare function aux_file(path: string, ext: string): string;
export declare function secure_random_token(length?: number, alphabet?: string): string;
export declare function random_choice(v: any[]): any;
export declare function close(obj: object, omit?: Set<string>): void;
export declare function contains(word: string, sub: string): boolean;
export declare function assertDefined<T>(val: T): asserts val is NonNullable<T>;
export declare function round1(num: number): number;
export declare function round2(num: number): number;
export declare function parse_number_input(input: any, round_number?: boolean, allow_negative?: boolean): number | undefined;
export declare function coerce_codomain_to_numbers(map: {
    [k: string]: any;
}): {
    [k: string]: number;
};
export declare function map_sum(a?: {
    [k: string]: number;
}, b?: {
    [k: string]: number;
}): {
    [k: string]: number;
};
export declare function map_diff(a?: {
    [k: string]: number;
}, b?: {
    [k: string]: number;
}): {
    [k: string]: number;
};
export declare function search_split(search: string): string[];
export declare function search_match(s: string, v: string[]): boolean;
export declare let RUNNING_IN_NODE: boolean;
export declare function to_json_socket(x: any): string;
export declare function from_json_socket(x: string): any;
export declare function to_safe_str(x: any): string;
export declare function date_parser(_key: string, value: any): any;
export declare function ISO_to_Date(s: string): Date;
export declare function from_json(x: string): any;
export declare function fix_json_dates(obj: any, date_keys?: "all" | string[]): any;
export declare function to_iso_path(d: Date): string;
export declare const has_key: (obj: object, path: string[] | string) => boolean;
export declare const values: {
    <T>(object: lodash.Dictionary<T> | lodash.NumericDictionary<T> | lodash.List<T> | null | undefined): T[];
    <T_1 extends object>(object: T_1 | null | undefined): T_1[keyof T_1][];
    (object: any): any[];
};
export declare function dict(v: [string, any][]): {
    [key: string]: any;
};
export declare function remove(arr: any[], val: any): void;
export declare const max: (x: any[]) => any;
export declare const min: (x: any[]) => any;
export declare function path_to_file(path: string, file: string): string;
export declare function original_path(path: string): string;
export declare function lower_email_address(email_address: any): string;
export declare function parse_user_search(query: string): {
    string_queries: string[][];
    email_queries: string[];
};
export declare function delete_trailing_whitespace(s: string): string;
export declare function retry_until_success(opts: {
    f: Function;
    start_delay?: number;
    max_delay?: number;
    factor?: number;
    max_tries?: number;
    max_time?: number;
    log?: Function;
    warn?: Function;
    name?: string;
    cb?: Function;
}): void;
export declare class StringCharMapping {
    private _to_char;
    private _next_char;
    _to_string: {
        [s: string]: string;
    };
    constructor(opts?: any);
    private find_next_char;
    to_string(strings: string[]): string;
    to_array(x: string): string[];
}
export declare const PROJECT_GROUPS: string[];
export declare function parse_bup_timestamp(s: string): Date;
export declare function hash_string(s: string): number;
export declare function parse_hashtags(t: string): [number, number][];
export declare function path_is_in_public_paths(path: string, paths: string[] | Set<string> | object | undefined): boolean;
export declare function containing_public_path(path: string, paths: string[] | Set<string> | object | undefined): undefined | string;
export declare const is_equal: (value: any, other: any) => boolean;
export declare function is_whitespace(s?: string): boolean;
export declare function lstrip(s: string): string;
export declare function date_to_snapshot_format(d: Date | undefined | null | number): string;
export declare function stripe_date(d: number): string;
export declare function to_money(n: number): string;
export declare function stripe_amount(units: number, currency: string): string;
export declare function get_array_range(arr: any[], value1: any, value2: any): any[];
export declare function seconds2hm(secs: number, longform?: boolean): string;
export declare function seconds2hms(secs: number, longform?: boolean, show_seconds?: boolean): string;
export declare function range(n: number): number[];
export declare function should_open_in_foreground(e: any): boolean;
export declare function enumerate(v: any[]): [number, any][];
export declare function to_human_list(arr: any[]): string;
export declare function console_init_filename(path: string): string;
export declare function has_null_leaf(obj: object): boolean;
export declare function peer_grading(students: string[], N?: number): {
    [student_id: string]: string[];
};
export declare function ticket_id_to_ticket_url(tid: string): string;
export declare function is_only_downloadable(s: string): boolean;
export declare function ensure_bound(x: number, min: number, max: number): number;
export declare function path_to_tab(name: string): string;
export declare function tab_to_path(name: string): string | undefined;
export declare function suggest_duplicate_filename(name: string): string;
export declare function top_sort(DAG: {
    [node: string]: string[];
}, opts?: {
    omit_sources?: boolean;
}): string[];
export declare function create_dependency_graph(obj: {
    [name: string]: Function & {
        dependency_names?: string;
    };
}): {
    [name: string]: string[];
};
export declare type OPERATORS = "!=" | "<>" | "<=" | ">=" | "==" | "<" | ">" | "=";
export declare const operators: OPERATORS[];
export declare function op_to_function(op: string): (a: any, b: any) => boolean;
export declare function obj_key_subs(obj: object, subs: {
    [key: string]: any;
}): void;
export declare function sanitize_html_attributes($: any, node: any): void;
export declare const analytics_cookie_name = "CC_ANA";
export declare function jupyter_language_to_name(lang: string): string;
export declare function closest_kernel_match(name: string, kernel_list: immutable.List<immutable.Map<string, string>>): immutable.Map<string, string>;
export declare function count(str: string, strsearch: string): number;
export declare function rpad_html(num: number, width: number, round_fn?: Function): string | number;
