"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2021 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.sanitize_nbconvert_path = void 0;
// All jupyter nbconvert invocation have to sanitize the full input path.
// The reason is https://github.com/jupyter/nbconvert/issues/911
//
// e.g. "foo*bar??baz[.xyz" → "foo[*]bar[?][?]baz[[].xyz"
function sanitize_nbconvert_path(path) {
    // this should be equivalent to glob.escape in python3
    // https://docs.python.org/3/library/glob.html#glob.escape
    return path.replace(/([\[*?\]])/g, "[$1]");
}
exports.sanitize_nbconvert_path = sanitize_nbconvert_path;
//# sourceMappingURL=sanitize-nbconvert.js.map