export var COMPUTE_STATES: {
    readonly archived: {
        readonly desc: "Project is stored in longterm storage, and will take even longer to start.";
        readonly icon: "file-archive";
        readonly display: "Archived";
        readonly stable: true;
        readonly to: {
            readonly closed: "unarchiving";
        };
        readonly commands: readonly ["unarchive"];
    };
    readonly unarchiving: {
        readonly desc: "Project is being copied from longterm storage; this may take several minutes depending on how many files you have.";
        readonly icon: "globe";
        readonly display: "Unarchiving";
        readonly to: {};
        readonly timeout: number;
        readonly commands: readonly ["status", "mintime"];
    };
    readonly archiving: {
        readonly desc: "Project is being moved to longterm storage.";
        readonly icon: "paper-plane";
        readonly display: "Archiving";
        readonly to: {};
        readonly timeout: number;
        readonly commands: readonly ["status", "mintime"];
    };
    readonly closed: {
        readonly desc: "Project is stored only as ZFS streams, which must be imported, so it will take longer to start.";
        readonly icon: "file-archive";
        readonly display: "Closed";
        readonly stable: true;
        readonly to: {
            readonly open: "opening";
            readonly archived: "archiving";
        };
        readonly commands: readonly ["open", "move", "status", "destroy", "mintime", "archive"];
    };
    readonly opening: {
        readonly desc: "Project is being imported; this may take several minutes depending on size and history.";
        readonly icon: "gears";
        readonly display: "Opening";
        readonly to: {};
        readonly timeout: number;
        readonly commands: readonly ["status", "mintime"];
    };
    readonly closing: {
        readonly desc: "Project is in the process of being closed.";
        readonly icon: "close";
        readonly display: "Closing";
        readonly to: {};
        readonly timeout: number;
        readonly commands: readonly ["status", "mintime"];
    };
    readonly opened: {
        readonly desc: "Project is available and ready to try to run.";
        readonly icon: "stop";
        readonly display: "Stopped";
        readonly stable: true;
        readonly to: {
            readonly start: "starting";
            readonly close: "closing";
        };
        readonly commands: readonly ["start", "close", "save", "copy_path", "mkdir", "directory_listing", "read_file", "network", "mintime", "disk_quota", "compute_quota", "status", "migrate_live", "ephemeral_state", "ephemeral_disk"];
    };
    readonly pending: {
        readonly desc: "Finding a place to run your project.  If nothing becomes available, reduce dedicated RAM or CPU, pay for members only hosting, or contact support.";
        readonly icon: "times-rectangle";
        readonly display: "Pending";
        readonly stable: true;
        readonly to: {
            readonly stop: "stopping";
        };
        readonly command: readonly ["stop"];
    };
    readonly starting: {
        readonly desc: "Project is starting up.";
        readonly icon: "flash";
        readonly display: "Starting";
        readonly timeout: 60;
        readonly commands: readonly ["save", "copy_path", "mkdir", "directory_listing", "read_file", "network", "mintime", "disk_quota", "compute_quota", "status"];
    };
    readonly stopping: {
        readonly desc: "Project is stopping.";
        readonly icon: "hand-stop";
        readonly display: "Stopping";
        readonly timeout: 60;
        readonly commands: readonly ["save", "copy_path", "mkdir", "directory_listing", "read_file", "network", "mintime", "disk_quota", "compute_quota", "status"];
    };
    readonly running: {
        readonly desc: "Project is running.";
        readonly icon: "run";
        readonly display: "Running";
        readonly stable: true;
        readonly to: {
            readonly stop: "stopping";
        };
        readonly commands: readonly ["stop", "save", "address", "copy_path", "mkdir", "directory_listing", "read_file", "network", "mintime", "disk_quota", "compute_quota", "status", "migrate_live"];
    };
};
export { RECENT_TIMES, RECENT_TIMES_KEY, SCHEMA, client_db, site_settings_conf, upgrades as PROJECT_UPGRADES, DEFAULT_QUOTAS, CURRENT_DATE as UPGRADES_CURRENT_DATE };
