import { SyncDoc } from "./sync-doc";
import { Client } from "./types";
declare type Program = "sage" | "bash";
declare type Input = any;
export declare class Evaluator {
    private syncdoc;
    private client;
    private inputs_table;
    private outputs_table;
    private sage_session;
    private state;
    private table_options;
    private create_synctable;
    private last_call_time;
    constructor(syncdoc: SyncDoc, client: Client, create_synctable: Function);
    init(): Promise<void>;
    close(): Promise<void>;
    private dbg;
    private init_eval_inputs;
    private init_eval_outputs;
    private set_state;
    private assert_not_closed;
    private assert_is_project;
    private assert_is_browser;
    call(opts: {
        program: Program;
        input: Input;
        cb?: Function;
    }): void;
    private execute_sage_code_hook;
    private handle_input_change;
    private init_project_evaluator;
    private ensure_sage_session_exists;
    private evaluate_using_sage;
    private evaluate_using_shell;
}
export {};
