import { Document } from "./types";
export interface Entry {
    time: Date;
    value: Document;
    start: number;
    last_used: Date;
}
export declare class PatchValueCache {
    private cache;
    invalidate(time: Date): void;
    prune(n: number): void;
    include(time: Date, value: Document, start: number): void;
    private keys;
    newest_value_at_most(time?: Date, strict?: boolean): Entry | undefined;
    get(time: Date | number): Entry | undefined;
    oldest_time(): Date | undefined;
    size(): number;
}
