/// <reference types="node" />
import { EventEmitter } from "events";
import { Client as Client0, FileWatcher as FileWatcher0 } from "../../generic/types";
import { SyncTable } from "../../../table/synctable";
export declare class FileWatcher extends EventEmitter implements FileWatcher0 {
    private path;
    constructor(path: string);
    close(): void;
}
export declare class Client extends EventEmitter implements Client0 {
    private _client_id;
    private initial_get_query;
    set_queries: any[];
    constructor(initial_get_query: {
        [table: string]: any[];
    }, client_id: string);
    server_time(): Date;
    is_user(): boolean;
    is_project(): boolean;
    dbg(_f: string): Function;
    mark_file(_opts: {
        project_id: string;
        path: string;
        action: string;
        ttl: number;
    }): void;
    log_error(opts: {
        project_id: string;
        path: string;
        string_id: string;
        error: any;
    }): void;
    query(opts: any): void;
    path_access(opts: {
        path: string;
        mode: string;
        cb: Function;
    }): void;
    path_exists(opts: {
        path: string;
        cb: Function;
    }): void;
    path_stat(opts: {
        path: string;
        cb: Function;
    }): void;
    path_read(opts: {
        path: string;
        maxsize_MB?: number;
        cb: Function;
    }): void;
    write_file(opts: {
        path: string;
        data: string;
        cb: Function;
    }): void;
    watch_file(opts: {
        path: string;
    }): FileWatcher;
    is_connected(): boolean;
    is_signed_in(): boolean;
    touch_project(_: any): void;
    query_cancel(_: any): void;
    alert_message(_: any): void;
    is_deleted(_filename: string, _project_id?: string): boolean;
    set_deleted(_filename: string, _project_id?: string): void;
    synctable_project(_project_id: string, query: any, options: any, throttle_changes?: number): Promise<SyncTable>;
    synctable_database(_query: any, _options: any, _throttle_changes?: number): Promise<SyncTable>;
    client_id(): string;
}
